## shiboken 0.2.0-1maemo1

=== CMakeLists.txt ===
include(icecc.cmake)
project(shiboken)

cmake_minimum_required(VERSION 2.6)

find_package(Qt4 4.5.0 REQUIRED)
find_package(ApiExtractor REQUIRED)
find_package(GeneratorRunner REQUIRED)

add_definitions(${QT_DEFINITIONS})

option(AVOID_PROTECTED_HACK "Avoid protected hack on generated bindings." FALSE)

if (NOT CMAKE_BUILD_TYPE)
    message("No build type provided. Setting to Debug by default")
    set(CMAKE_BUILD_TYPE "Debug")
endif()

if (MSVC)
    set(CMAKE_CXX_FLAGS "/DWIN32 /D_WINDOWS /w /EHsc- /GS- /GR- /DLIBSHIBOKEN_BUILD -D_SCL_SECURE_NO_WARNINGS")
else()
    if (${CMAKE_BUILD_TYPE} STREQUAL "Release")
        set(CMAKE_CXX_FLAGS "-Wall -Wno-strict-aliasing -DNDEBUG -O2 -Wl,-O1 -Wl,--hash-style=gnu -fvisibility=hidden")
    else()
        set(CMAKE_CXX_FLAGS "-g -Wall -Wno-strict-aliasing -fvisibility=hidden")
    endif()
endif()
if (WIN32 OR AVOID_PROTECTED_HACK)
    message(STATUS "Avoiding protected hack!")
    add_definitions("-DAVOID_PROTECTED_HACK")
else()
    message(STATUS "Using protected hack!")
endif()

set(LIB_SUFFIX "" CACHE STRING "Define suffix of directory name (32/64)" )
set(LIB_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX}" CACHE PATH "The subdirectory relative to the install prefix where libraries will be installed (default is /lib${LIB_SUFFIX})" FORCE)

set(shiboken_MAJOR_VERSION "0")
set(shiboken_MINOR_VERSION "2")
set(shiboken_MICRO_VERSION "0")
set(shiboken_VERSION "${shiboken_MAJOR_VERSION}.${shiboken_MINOR_VERSION}.${shiboken_MICRO_VERSION}")

set(shiboken_SRC
cppgenerator.cpp
headergenerator.cpp
overloaddata.cpp
shiboken.cpp
shibokengenerator.cpp
)

include_directories(${CMAKE_CURRENT_SOURCE_DIR}
                    ${APIEXTRACTOR_INCLUDE_DIR}
                    ${GENERATORRUNNER_INCLUDE_DIR}
                    ${QT_INCLUDE_DIR}
                    ${QT_QTCORE_INCLUDE_DIR})

add_library(shiboken_generator SHARED ${shiboken_SRC})

target_link_libraries(shiboken_generator
                      ${APIEXTRACTOR_LIBRARY}
                      ${GENERATORRUNNER_LIBRARY}
                      ${QT_QTCORE_LIBRARY})

add_executable(shiboken main.cpp)
target_link_libraries(shiboken ${QT_QTCORE_LIBRARY})

# uninstall target
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake"
               "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
               IMMEDIATE @ONLY)
add_custom_target(uninstall "${CMAKE_COMMAND}"
                  -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")

enable_testing()

add_subdirectory(libshiboken)
add_subdirectory(tests)

set(ARCHIVE_NAME ${CMAKE_PROJECT_NAME}-${shiboken_VERSION})
add_custom_target(dist
    COMMAND mkdir -p "${CMAKE_BINARY_DIR}/${ARCHIVE_NAME}" &&
            git log > "${CMAKE_BINARY_DIR}/${ARCHIVE_NAME}/ChangeLog" &&
            git archive --prefix=${ARCHIVE_NAME}/ HEAD --format=tar -o "${CMAKE_BINARY_DIR}/${ARCHIVE_NAME}.tar" &&
            tar -C "${CMAKE_BINARY_DIR}" --owner=root --group=root -r "${ARCHIVE_NAME}/ChangeLog" -f "${CMAKE_BINARY_DIR}/${ARCHIVE_NAME}.tar" &&
            bzip2 -f9 "${CMAKE_BINARY_DIR}/${ARCHIVE_NAME}.tar" &&
            echo "Source package created at ${CMAKE_BINARY_DIR}/${ARCHIVE_NAME}.tar.bz2.\n"
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})

add_dependencies(shiboken shiboken_generator)

install(TARGETS shiboken_generator DESTINATION "${GENERATORRUNNER_PLUGIN_DIR}")
install(TARGETS shiboken DESTINATION bin)

=== libshiboken/CMakeLists.txt ===
project(libshiboken)

find_package(PythonLibs REQUIRED)

set(libshiboken_MAJOR_VERSION ${shiboken_MAJOR_VERSION})
set(libshiboken_MINOR_VERSION ${shiboken_MINOR_VERSION})
set(libshiboken_MICRO_VERSION ${shiboken_MICRO_VERSION})
set(libshiboken_VERSION "${libshiboken_MAJOR_VERSION}.${libshiboken_MINOR_VERSION}.${libshiboken_MICRO_VERSION}")


configure_file("${CMAKE_CURRENT_SOURCE_DIR}/ShibokenConfig.cmake.in"
               "${CMAKE_CURRENT_BINARY_DIR}/ShibokenConfig.cmake" @ONLY)
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/ShibokenVersion.cmake.in"
               "${CMAKE_CURRENT_BINARY_DIR}/ShibokenVersion.cmake" @ONLY)
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/shiboken.pc.in"
               "${CMAKE_CURRENT_BINARY_DIR}/shiboken.pc" @ONLY)

set(libshiboken_SRC
basewrapper.cpp
helper.cpp
pyenum.cpp
bindingmanager.cpp
typeresolver.cpp
)

include_directories(${CMAKE_CURRENT_SOURCE_DIR}
                    ${PYTHON_INCLUDE_PATH}
                    ${CMAKE_SOURCE_DIR}/ext/sparsehash)
add_library(libshiboken SHARED ${libshiboken_SRC})
set_property(TARGET libshiboken PROPERTY PREFIX "")
target_link_libraries(libshiboken
                      ${PYTHON_LIBRARIES})
set_target_properties(libshiboken PROPERTIES VERSION ${libshiboken_VERSION} SOVERSION ${libshiboken_MAJOR_VERSION})

install(DIRECTORY . DESTINATION include/shiboken
        FILES_MATCHING PATTERN "*.h"
        PATTERN ".git" EXCLUDE
        )
install(TARGETS libshiboken DESTINATION "${LIB_INSTALL_DIR}")
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/ShibokenConfig.cmake"
        DESTINATION "${LIB_INSTALL_DIR}/cmake/Shiboken-${libshiboken_VERSION}")
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/ShibokenVersion.cmake"
        DESTINATION "${LIB_INSTALL_DIR}/cmake/Shiboken-${libshiboken_VERSION}")
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/shiboken.pc"
        DESTINATION "${LIB_INSTALL_DIR}/pkgconfig")

=== tests/CMakeLists.txt ===
add_subdirectory(libsample)
add_subdirectory(libother)
add_subdirectory(samplebinding)
add_subdirectory(otherbinding)

file(GLOB TEST_FILES samplebinding/*_test.py otherbinding/*_test.py)

set(test_blacklist "")

find_package(PythonInterp REQUIRED)

foreach(test_file ${TEST_FILES})
    string(REGEX MATCH "/([^/]+)_test.py" test_name ${test_file})
    list(FIND test_blacklist ${CMAKE_MATCH_1} expect_fail)
    add_test("${CMAKE_MATCH_1}" sh
             "${CMAKE_CURRENT_SOURCE_DIR}/run_test.sh"
             "${libsample_BINARY_DIR}:${libother_BINARY_DIR}:${libshiboken_BINARY_DIR}"
             "${sample_BINARY_DIR}:${other_BINARY_DIR}"
             "${PYTHON_EXECUTABLE}"
             "${test_file}")
    set_tests_properties(${CMAKE_MATCH_1} PROPERTIES TIMEOUT 5)
    if (${expect_fail} GREATER -1)
        set_tests_properties(${CMAKE_MATCH_1} PROPERTIES WILL_FAIL TRUE)
    endif(${expect_fail} GREATER -1)

# Should set python path here
# Looks like it's fixed in 2.8:
# http://www.vtk.org/Bug/print_bug_page.php?bug_id=7885
endforeach(test_file ${TEST_FILES})

=== tests/otherbinding/CMakeLists.txt ===
project(other)

set(other_TYPESYSTEM
${CMAKE_CURRENT_SOURCE_DIR}/typesystem_other.xml
)

set(other_SRC
${CMAKE_CURRENT_BINARY_DIR}/other/extendsnoimplicitconversion_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/other/number_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/other/otherderived_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/other/othermultiplederived_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/other/otherobjecttype_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/other/other_module_wrapper.cpp
)

find_program(GENERATOR generatorrunner REQUIRED)

add_custom_command(OUTPUT ${other_SRC}
COMMAND ${GENERATOR} --generatorSet=${shiboken_BINARY_DIR}/shiboken_generator${CMAKE_RELEASE_POSTFIX}${CMAKE_DEBUG_POSTFIX} --enable-parent-ctor-heuristic
        ${CMAKE_CURRENT_SOURCE_DIR}/global.h
        --include-paths=${libother_SOURCE_DIR}:${libsample_SOURCE_DIR}:${libsample_SOURCE_DIR}/..
        --typesystem-paths=${CMAKE_CURRENT_SOURCE_DIR}:${sample_SOURCE_DIR}
        --output-directory=${CMAKE_CURRENT_BINARY_DIR}
        ${other_TYPESYSTEM}
WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
COMMENT "Running generator for test binding..."
)

include_directories(${CMAKE_CURRENT_SOURCE_DIR}
                    ${CMAKE_SOURCE_DIR}
                    ${PYTHON_INCLUDE_PATH}
                    ${libother_SOURCE_DIR}
                    ${libsample_SOURCE_DIR}
                    ${libsample_SOURCE_DIR}/..
                    ${sample_BINARY_DIR}
                    ${sample_BINARY_DIR}/sample
                    ${libshiboken_SOURCE_DIR})
add_library(other MODULE ${other_SRC})
set_property(TARGET other PROPERTY PREFIX "")
target_link_libraries(other
                      libother
                      libsample
                      ${PYTHON_LIBRARIES}
                      libshiboken)

add_dependencies(other sample shiboken_generator)

=== tests/samplebinding/CMakeLists.txt ===
project(sample)

set(sample_TYPESYSTEM
${CMAKE_CURRENT_SOURCE_DIR}/typesystem_sample.xml
)

set(sample_SRC
${CMAKE_CURRENT_BINARY_DIR}/sample/abstractmodifications_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/abstract_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/base1_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/base2_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/base3_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/base4_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/base5_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/base6_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/blackbox_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/bucket_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/collector_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/derived_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/derived_someinnerclass_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/echo_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/event_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/implicitconv_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/implicitbase_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/implicittarget_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/sortedoverload_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/intwrapper_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/injectcode_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/listuser_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/mapuser_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/mderived1_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/mderived2_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/mderived3_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/mderived4_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/mderived5_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/modifications_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/noimplicitconversion_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/nondefaultctor_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/objecttype_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/objecttypelayout_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/objectview_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/oddbooluser_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/overload_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/pairuser_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/point_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/pointerholder_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/polygon_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/privatedtor_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/protectednonpolymorphic_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/protectedpolymorphic_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/protectedpolymorphicdaughter_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/protectedpolymorphicgranddaughter_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/protectedvirtualdestructor_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/reference_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/sample_module_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/samplenamespace_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/simplefile_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/size_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/sonofmderived1_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/str_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/strlist_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/time_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/virtualdaughter_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/virtualdtor_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/virtualmethods_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/voidholder_wrapper.cpp
)

find_program(GENERATOR generatorrunner REQUIRED)

add_custom_command(OUTPUT ${sample_SRC}
COMMAND ${GENERATOR} --generatorSet=${shiboken_BINARY_DIR}/shiboken_generator${CMAKE_RELEASE_POSTFIX}${CMAKE_DEBUG_POSTFIX} --enable-parent-ctor-heuristic
        ${CMAKE_CURRENT_SOURCE_DIR}/global.h
        --include-paths=${libsample_SOURCE_DIR}
        --typesystem-paths=${CMAKE_CURRENT_SOURCE_DIR}
        --output-directory=${CMAKE_CURRENT_BINARY_DIR}
        ${sample_TYPESYSTEM}
WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
COMMENT "Running generator for test binding..."
)

include_directories(${CMAKE_CURRENT_SOURCE_DIR}
                    ${CMAKE_SOURCE_DIR}
                    ${PYTHON_INCLUDE_PATH}
                    ${libsample_SOURCE_DIR}
                    ${libshiboken_SOURCE_DIR})
add_library(sample MODULE ${sample_SRC})
set_property(TARGET sample PROPERTY PREFIX "")
target_link_libraries(sample
                      libsample
                      ${PYTHON_LIBRARIES}
                      libshiboken)

add_dependencies(sample shiboken_generator)

=== debian/changelog ===
shiboken (0.2.0-1maemo1) unstable; urgency=low

  * Maemo 5 build.

 -- Willer Moreira <willer.moreira@openbossa.org>  Fri, 26 Mar 2010 12:31:26 -0400

shiboken (0.2.0-1pyside0~ppa1) karmic; urgency=low

  * Reuse Debian packaging for Ubuntu (PPA) and Maemo builds.
  * debian/source/format: downgrade to 1.0 format for karmic.
  * Remove dpkg-dev and libsparsehash-dev build dependencies.
  * Remove debian/libshiboken0.symbols (requires newer dpkg-dev)

 -- Anderson Lizardo <anderson.lizardo@openbossa.org>  Fri, 26 Mar 2010 09:31:26 -0400

shiboken (0.2.0-1) experimental; urgency=low

  * Initial upload (Closes: #569173).

  * Add symbols for libshiboken0 using (c++) filter.
  * Build for multiple python versions.
  * Update Build-Depends
  * Enable the build-tests
  * Add debian/watch file.
  * Add help2man manpage for shiboken
  * Patches
    + use_original_sparsehash.patch:  Don't use embedded sparsehash.
    + fix_tests.patch:                Work for different python versions.
    + use_soname_from_version.patch:  Force a SONAME (MAJOR_version) to
                                      libshiboken

 -- Didier Raboud <didier@raboud.com>  Fri, 26 Mar 2010 12:56:52 +0000

=== debian/control ===
Source: shiboken
Section: devel
Priority: extra
Maintainer: PySide Team <pyside@openbossa.org>
XSBC-Original-Maintainer: Debian Python Modules Team <python-modules-team@lists.alioth.debian.org>
Build-Depends: debhelper7 (>= 7.3.12), cmake (>= 2.6.0),
	libqt4-dev (>= 4.5.0), libapiextractor-dev (>= 0.4.0), generatorrunner (>= 0.4.0), libgenrunner-dev (>= 0.4.0),
	python-all-dev, python-all-dbg
XS-Python-Version: >= 2.5
Standards-Version: 3.8.4
Vcs-Svn: svn://svn.debian.org/python-modules/packages/shiboken/trunk/
Vcs-Browser: http://svn.debian.org/wsvn/python-modules/packages/shiboken/?op=log
Homepage: http://www.pyside.org/

Package: shiboken
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: CPython bindings generator for C++ libraries
 Shiboken is a bindings generator for C++ libraries that outputs CPython
 source code. It uses generatorrunner and apiextractor to collect information
 from library headers, merging modifications and handwritten code defined in the
 typesystem description.
 .
 Shiboken is the binding generator used to create the PySide bindings.

Package: libshiboken0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: CPython bindings generator for C++ libraries - shared library
 Shiboken is a bindings generator for C++ libraries that outputs CPython
 source code. It uses generatorrunner and apiextractor to collect information
 from library headers, merging modifications and handwritten code defined in the
 typesystem description.
 .
 This is the shared library used by shiboken.

Package: libshiboken-dev
Section: libdevel
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libshiboken0 (= ${binary:Version})
Description: development files for the shiboken bindings generator library
 Shiboken is a bindings generator for C++ libraries that outputs CPython
 source code. It uses generatorrunner and apiextractor to collect information
 from library headers, merging modifications and handwritten code defined in the
 typesystem description.
 .
 This package contains the development files for the library.

Package: shiboken-dbg
Section: debug
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
         libshiboken0 (= ${binary:Version}),
         shiboken (= ${binary:Version})
Description: debugging symbols for shiboken and its library
 Shiboken is a bindings generator for C++ libraries that outputs CPython
 source code. It uses generatorrunner and apiextractor to collect information
 from library headers, merging modifications and handwritten code defined in the
 typesystem description.
 .
 This package contains the debugging symbols for shiboken and libshiboken0.

=== debian/rules ===
#!/usr/bin/make -f

# Allow to find Qt 4.6 on Maemo
PATH := /usr/bin/dh7:$(PATH)
export PATH

%:
	dh --buildsystem=cmake --parallel $@

# Python versions (default is first)
PYVERSIONS=$(shell pyversions -v -r)
DEFAULT_PY=$(shell pyversions -v -d)

#### CONFIGURE ####

override_dh_auto_configure: $(PYVERSIONS:%=override_dh_auto_configure-%)

override_dh_auto_configure_dbg-%:
	mkdir -p build-$*-dbg
	dh_auto_configure --builddirectory=build-$*-dbg -- \
	-DCMAKE_BUILD_TYPE:STRING="Debug" \
	-DCMAKE_SKIP_RPATH=true \
	-DCMAKE_MODULE_PATH="$(shell pwd)/debian/cmake" \
	-DCMAKE_PYTHON_VERSION="$*-dbg;$*" \
	-DCMAKE_PYTHONLIB_VERSION="$*_d;$*" \
	-DCMAKE_DEBUG_POSTFIX=$(shell echo -py$*_d | sed -e 's/\.//g' -)

override_dh_auto_configure-%:
	mkdir -p build-$*
	dh_auto_configure --builddirectory=build-$* -- \
	-DCMAKE_BUILD_TYPE:STRING="Release" \
	-DCMAKE_SKIP_RPATH=true \
	-DCMAKE_MODULE_PATH="$(shell pwd)/debian/cmake" \
	-DCMAKE_PYTHON_VERSION=$* \
	-DCMAKE_PYTHONLIB_VERSION=$* \
	-DCMAKE_RELEASE_POSTFIX=$(shell echo -py$* | sed -e 's/\.//g' -)

#### BUILD ####

override_dh_auto_build: $(PYVERSIONS:%=override_dh_auto_build-%)

override_dh_auto_build_dbg-%:
	dh_auto_build --builddirectory=build-$*-dbg

override_dh_auto_build-%:
	dh_auto_build --builddirectory=build-$*

#### INSTALL ####

override_dh_auto_install: $(PYVERSIONS:%=override_dh_auto_install-%)

override_dh_auto_install_dbg-%:
	dh_auto_install --builddirectory=build-$*-dbg --destdir=debian/tmp-dbg

override_dh_auto_install-%:
	dh_auto_install --builddirectory=build-$*

#### STRIP ####
override_dh_strip:
	dh_strip --dbg-package=shiboken-dbg --exclude=_d.so

#### TEST ####

override_dh_auto_test: $(PYVERSIONS:%=override_dh_auto_test-%)

override_dh_auto_test_dbg-%: 
	dh_auto_test --builddirectory=build-$*-dbg

override_dh_auto_test-%: prepare_test-%
	dh_auto_test --builddirectory=build-$*

prepare_test-%:
	# Prepare the convenience symlinks for the tests
	$(shell ln -s libother`echo -py$* | sed -e 's/\.//g' -`.so \
	   build-$*/tests/libother/libother.so )
	$(shell ln -s libsample`echo -py$* | sed -e 's/\.//g' -`.so \
	   build-$*/tests/libsample/libsample.so )
	$(shell ln -s other`echo -py$* | sed -e 's/\.//g' -`.so \
	   build-$*/tests/otherbinding/other.so )
	$(shell ln -s sample`echo -py$* | sed -e 's/\.//g' -`.so \
	   build-$*/tests/samplebinding/sample.so )

#### CLEAN ####
override_dh_auto_clean:
	rm -rf build-*
	rm -rf debian/tmp-dbg

#### DEBIAN INSTALL ####

override_dh_install:
	# Install symlinks for default version
	$(shell ln -s libshiboken_generator`echo -py${DEFAULT_PY} | sed -e 's/\.//g' -`.so \
	              debian/tmp/usr/lib/generatorrunner/libshiboken_generator.so )
	$(shell ln -s libshiboken`echo -py${DEFAULT_PY} | sed -e 's/\.//g' -`.so \
	              debian/tmp/usr/lib/libshiboken.so )
	dh_install --list-missing

#### Shared libs ####
override_dh_makeshlibs:
	# Package shiboken ships a usr/lib/generatorrunner/*.so plugin. No shared libs in there.
	dh_makeshlibs -Nshiboken

## shiboken 0.3.1-0maemo1

=== CMakeLists.txt ===
--- 
+++ 
@@ -10,6 +10,7 @@
 add_definitions(${QT_DEFINITIONS})
 
 option(AVOID_PROTECTED_HACK "Avoid protected hack on generated bindings." FALSE)
+option(BUILD_TESTS "Build tests." TRUE)
 
 if (NOT CMAKE_BUILD_TYPE)
     message("No build type provided. Setting to Debug by default")
@@ -36,8 +37,8 @@
 set(LIB_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX}" CACHE PATH "The subdirectory relative to the install prefix where libraries will be installed (default is /lib${LIB_SUFFIX})" FORCE)
 
 set(shiboken_MAJOR_VERSION "0")
-set(shiboken_MINOR_VERSION "2")
-set(shiboken_MICRO_VERSION "0")
+set(shiboken_MINOR_VERSION "3")
+set(shiboken_MICRO_VERSION "1")
 set(shiboken_VERSION "${shiboken_MAJOR_VERSION}.${shiboken_MINOR_VERSION}.${shiboken_MICRO_VERSION}")
 
 set(shiboken_SRC
@@ -71,16 +72,21 @@
 add_custom_target(uninstall "${CMAKE_COMMAND}"
                   -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")
 
-enable_testing()
+if (BUILD_TESTS)
+    enable_testing()
+endif()
 
 add_subdirectory(libshiboken)
-add_subdirectory(tests)
+
+if (BUILD_TESTS)
+    add_subdirectory(tests)
+endif()
 
 set(ARCHIVE_NAME ${CMAKE_PROJECT_NAME}-${shiboken_VERSION})
 add_custom_target(dist
     COMMAND mkdir -p "${CMAKE_BINARY_DIR}/${ARCHIVE_NAME}" &&
             git log > "${CMAKE_BINARY_DIR}/${ARCHIVE_NAME}/ChangeLog" &&
-            git archive --prefix=${ARCHIVE_NAME}/ HEAD --format=tar -o "${CMAKE_BINARY_DIR}/${ARCHIVE_NAME}.tar" &&
+            git archive --prefix=${ARCHIVE_NAME}/ HEAD --format=tar --output="${CMAKE_BINARY_DIR}/${ARCHIVE_NAME}.tar" &&
             tar -C "${CMAKE_BINARY_DIR}" --owner=root --group=root -r "${ARCHIVE_NAME}/ChangeLog" -f "${CMAKE_BINARY_DIR}/${ARCHIVE_NAME}.tar" &&
             bzip2 -f9 "${CMAKE_BINARY_DIR}/${ARCHIVE_NAME}.tar" &&
             echo "Source package created at ${CMAKE_BINARY_DIR}/${ARCHIVE_NAME}.tar.bz2.\n"

=== tests/samplebinding/CMakeLists.txt ===
--- 
+++ 
@@ -45,6 +45,7 @@
 ${CMAKE_CURRENT_BINARY_DIR}/sample/point_wrapper.cpp
 ${CMAKE_CURRENT_BINARY_DIR}/sample/pointerholder_wrapper.cpp
 ${CMAKE_CURRENT_BINARY_DIR}/sample/polygon_wrapper.cpp
+${CMAKE_CURRENT_BINARY_DIR}/sample/privatector_wrapper.cpp
 ${CMAKE_CURRENT_BINARY_DIR}/sample/privatedtor_wrapper.cpp
 ${CMAKE_CURRENT_BINARY_DIR}/sample/protectednonpolymorphic_wrapper.cpp
 ${CMAKE_CURRENT_BINARY_DIR}/sample/protectedpolymorphic_wrapper.cpp
@@ -54,6 +55,10 @@
 ${CMAKE_CURRENT_BINARY_DIR}/sample/reference_wrapper.cpp
 ${CMAKE_CURRENT_BINARY_DIR}/sample/sample_module_wrapper.cpp
 ${CMAKE_CURRENT_BINARY_DIR}/sample/samplenamespace_wrapper.cpp
+${CMAKE_CURRENT_BINARY_DIR}/sample/samplenamespace_someclass_someinnerclass_okthisisrecursiveenough_wrapper.cpp
+${CMAKE_CURRENT_BINARY_DIR}/sample/samplenamespace_someclass_someinnerclass_wrapper.cpp
+${CMAKE_CURRENT_BINARY_DIR}/sample/samplenamespace_someclass_wrapper.cpp
+${CMAKE_CURRENT_BINARY_DIR}/sample/samplenamespace_derivedfromnamespace_wrapper.cpp
 ${CMAKE_CURRENT_BINARY_DIR}/sample/simplefile_wrapper.cpp
 ${CMAKE_CURRENT_BINARY_DIR}/sample/size_wrapper.cpp
 ${CMAKE_CURRENT_BINARY_DIR}/sample/sonofmderived1_wrapper.cpp
@@ -69,7 +74,7 @@
 find_program(GENERATOR generatorrunner REQUIRED)
 
 add_custom_command(OUTPUT ${sample_SRC}
-COMMAND ${GENERATOR} --generatorSet=${shiboken_BINARY_DIR}/shiboken_generator${CMAKE_RELEASE_POSTFIX}${CMAKE_DEBUG_POSTFIX} --enable-parent-ctor-heuristic
+COMMAND ${GENERATOR} --generatorSet=${shiboken_BINARY_DIR}/shiboken_generator --enable-parent-ctor-heuristic
         ${CMAKE_CURRENT_SOURCE_DIR}/global.h
         --include-paths=${libsample_SOURCE_DIR}
         --typesystem-paths=${CMAKE_CURRENT_SOURCE_DIR}

=== debian/changelog ===
shiboken (0.3.1-0maemo1) unstable; urgency=low

  * Maemo 5 build.

 -- Willer Moreira <willer.moreira@openbossa.org>  Tue, 04 May 2010 16:56:36 -0400

shiboken (0.3.1-0) unstable; urgency=low

  * Bump to 0.3.1 based on maemo 0.2.0 packaging.

 -- Lauro Neto <lauro.neto@openbossa.org>  Tue, 04 May 2010 11:56:36 -0300

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: PySide Team <pyside@openbossa.org>
 XSBC-Original-Maintainer: Debian Python Modules Team <python-modules-team@lists.alioth.debian.org>
 Build-Depends: debhelper7 (>= 7.3.12), cmake (>= 2.6.0),
-	libqt4-dev (>= 4.5.0), libapiextractor-dev (>= 0.4.0), generatorrunner (>= 0.4.0), libgenrunner-dev (>= 0.4.0),
+	libqt4-dev (>= 4.5.0), libapiextractor-dev (>= 0.5.1), generatorrunner (>= 0.4.2), libgenrunner-dev (>= 0.4.2),
 	python-all-dev, python-all-dbg
 XS-Python-Version: >= 2.5
 Standards-Version: 3.8.4
@@ -23,9 +23,11 @@
  .
  Shiboken is the binding generator used to create the PySide bindings.
 
-Package: libshiboken0
+Package: libshiboken0.3
 Section: libs
 Architecture: any
+Conflicts: libshiboken0 (<< 0.3.0)
+Replaces: libshiboken0 (<< 0.3.0)
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: CPython bindings generator for C++ libraries - shared library
  Shiboken is a bindings generator for C++ libraries that outputs CPython
@@ -38,7 +40,7 @@
 Package: libshiboken-dev
 Section: libdevel
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, libshiboken0 (= ${binary:Version})
+Depends: ${shlibs:Depends}, ${misc:Depends}, libshiboken0.3 (= ${binary:Version})
 Description: development files for the shiboken bindings generator library
  Shiboken is a bindings generator for C++ libraries that outputs CPython
  source code. It uses generatorrunner and apiextractor to collect information
@@ -51,7 +53,7 @@
 Section: debug
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends},
-         libshiboken0 (= ${binary:Version}),
+         libshiboken0.3 (= ${binary:Version}),
          shiboken (= ${binary:Version})
 Description: debugging symbols for shiboken and its library
  Shiboken is a bindings generator for C++ libraries that outputs CPython

## shiboken 0.3.2-1maemo1

=== CMakeLists.txt ===
--- 
+++ 
@@ -12,21 +12,22 @@
 option(AVOID_PROTECTED_HACK "Avoid protected hack on generated bindings." FALSE)
 option(BUILD_TESTS "Build tests." TRUE)
 
-if (NOT CMAKE_BUILD_TYPE)
-    message("No build type provided. Setting to Debug by default")
-    set(CMAKE_BUILD_TYPE "Debug")
+if(MSVC)
+    set(CMAKE_CXX_FLAGS "/DWIN32 /D_WINDOWS /w /EHsc- /GS- /GR- /DLIBSHIBOKEN_BUILD -D_SCL_SECURE_NO_WARNINGS")
+elseif(CMAKE_HOST_UNIX)
+    option(ENABLE_GCC_OPTIMIZATION "Enable specific GCC flags to optimization library size and performance. Only available on Release Mode" 0)
+    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -fvisibility=hidden")
+    set(CMAKE_CXX_FLAGS_DEBUG "-g")
+    if(ENABLE_GCC_OPTIMIZATION)
+        set(CMAKE_BUILD_TYPE Release)
+        set(CMAKE_CXX_FLAGS_RELEASE "-DNDEBUG -Os -Wno-strict-aliasing -Wl,-O1")
+        if(NOT CMAKE_HOST_APPLE)
+            set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wl,--hash-style=gnu")
+        endif()
+    endif()
 endif()
 
-if (MSVC)
-    set(CMAKE_CXX_FLAGS "/DWIN32 /D_WINDOWS /w /EHsc- /GS- /GR- /DLIBSHIBOKEN_BUILD -D_SCL_SECURE_NO_WARNINGS")
-else()
-    if (${CMAKE_BUILD_TYPE} STREQUAL "Release")
-        set(CMAKE_CXX_FLAGS "-Wall -Wno-strict-aliasing -DNDEBUG -O2 -Wl,-O1 -Wl,--hash-style=gnu -fvisibility=hidden")
-    else()
-        set(CMAKE_CXX_FLAGS "-g -Wall -Wno-strict-aliasing -fvisibility=hidden")
-    endif()
-endif()
-if (WIN32 OR AVOID_PROTECTED_HACK)
+if(WIN32 OR AVOID_PROTECTED_HACK)
     message(STATUS "Avoiding protected hack!")
     add_definitions("-DAVOID_PROTECTED_HACK")
 else()
@@ -38,7 +39,7 @@
 
 set(shiboken_MAJOR_VERSION "0")
 set(shiboken_MINOR_VERSION "3")
-set(shiboken_MICRO_VERSION "1")
+set(shiboken_MICRO_VERSION "2")
 set(shiboken_VERSION "${shiboken_MAJOR_VERSION}.${shiboken_MINOR_VERSION}.${shiboken_MICRO_VERSION}")
 
 set(shiboken_SRC

=== doc/Makefile ===
# Makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
PAPER         =

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d _build/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .

.PHONY: help clean html dirhtml pickle json htmlhelp qthelp latex changes linkcheck doctest

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html      to make standalone HTML files"
	@echo "  dirhtml   to make HTML files named index.html in directories"
	@echo "  pickle    to make pickle files"
	@echo "  json      to make JSON files"
	@echo "  htmlhelp  to make HTML files and a HTML help project"
	@echo "  qthelp    to make HTML files and a qthelp project"
	@echo "  latex     to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  changes   to make an overview of all changed/added/deprecated items"
	@echo "  linkcheck to check all external links for integrity"
	@echo "  doctest   to run all doctests embedded in the documentation (if enabled)"

clean:
	-rm -rf _build/*

html:
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) _build/html
	@echo
	@echo "Build finished. The HTML pages are in _build/html."

dirhtml:
	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) _build/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in _build/dirhtml."

pickle:
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) _build/pickle
	@echo
	@echo "Build finished; now you can process the pickle files."

json:
	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) _build/json
	@echo
	@echo "Build finished; now you can process the JSON files."

htmlhelp:
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) _build/htmlhelp
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in _build/htmlhelp."

qthelp:
	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) _build/qthelp
	@echo
	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
	      ".qhcp project file in _build/qthelp, like this:"
	@echo "# qcollectiongenerator _build/qthelp/PyQtB.qhcp"
	@echo "To view the help file:"
	@echo "# assistant -collectionFile _build/qthelp/PyQtB.qhc"

latex:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) _build/latex
	@echo
	@echo "Build finished; the LaTeX files are in _build/latex."
	@echo "Run \`make all-pdf' or \`make all-ps' in that directory to" \
	      "run these through (pdf)latex."

changes:
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) _build/changes
	@echo
	@echo "The overview file is in _build/changes."

linkcheck:
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) _build/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in _build/linkcheck/output.txt."

doctest:
	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) _build/doctest
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in _build/doctest/output.txt."

=== libshiboken/CMakeLists.txt ===
--- 
+++ 
@@ -6,6 +6,7 @@
 set(libshiboken_MINOR_VERSION ${shiboken_MINOR_VERSION})
 set(libshiboken_MICRO_VERSION ${shiboken_MICRO_VERSION})
 set(libshiboken_VERSION "${libshiboken_MAJOR_VERSION}.${libshiboken_MINOR_VERSION}.${libshiboken_MICRO_VERSION}")
+set(libshiboken_SOVERSION "${libshiboken_MAJOR_VERSION}.${libshiboken_MINOR_VERSION}")
 
 
 configure_file("${CMAKE_CURRENT_SOURCE_DIR}/ShibokenConfig.cmake.in"
@@ -30,12 +31,23 @@
 set_property(TARGET libshiboken PROPERTY PREFIX "")
 target_link_libraries(libshiboken
                       ${PYTHON_LIBRARIES})
-set_target_properties(libshiboken PROPERTIES VERSION ${libshiboken_VERSION} SOVERSION ${libshiboken_MAJOR_VERSION})
+set_target_properties(libshiboken PROPERTIES VERSION ${libshiboken_VERSION} SOVERSION ${libshiboken_SOVERSION})
 
-install(DIRECTORY . DESTINATION include/shiboken
-        FILES_MATCHING PATTERN "*.h"
-        PATTERN ".git" EXCLUDE
-        )
+install(FILES
+        autodecref.h
+        basewrapper.h
+        bindingmanager.h
+        conversions.h
+        gilstate.h
+        helper.h
+        pyenum.h
+        python25compat.h
+        sbkdbg.h
+        shiboken.h
+        shibokenmacros.h
+        threadstatesaver.h
+        typeresolver.h
+        DESTINATION include/shiboken)
 install(TARGETS libshiboken DESTINATION "${LIB_INSTALL_DIR}")
 install(FILES "${CMAKE_CURRENT_BINARY_DIR}/ShibokenConfig.cmake"
         DESTINATION "${LIB_INSTALL_DIR}/cmake/Shiboken-${libshiboken_VERSION}")

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -14,7 +14,7 @@
     list(FIND test_blacklist ${CMAKE_MATCH_1} expect_fail)
     add_test("${CMAKE_MATCH_1}" sh
              "${CMAKE_CURRENT_SOURCE_DIR}/run_test.sh"
-             "${libsample_BINARY_DIR}:${libother_BINARY_DIR}:${libshiboken_BINARY_DIR}"
+             "${libsample_BINARY_DIR}:${libshiboken_BINARY_DIR}"
              "${sample_BINARY_DIR}:${other_BINARY_DIR}"
              "${PYTHON_EXECUTABLE}"
              "${test_file}")

=== tests/libother/CMakeLists.txt ===
project(libother)

set(libother_SRC
number.cpp
otherderived.cpp
otherobjecttype.cpp
)

add_definitions("-DLIBOTHER_BUILD")
add_library(libother SHARED ${libother_SRC})
set_property(TARGET libother PROPERTY PREFIX "")

include_directories(${CMAKE_CURRENT_SOURCE_DIR}
                    ${libsample_SOURCE_DIR}
                    ${libsample_SOURCE_DIR}/..)
target_link_libraries(libother libsample)

=== tests/otherbinding/CMakeLists.txt ===
--- 
+++ 
@@ -16,7 +16,7 @@
 find_program(GENERATOR generatorrunner REQUIRED)
 
 add_custom_command(OUTPUT ${other_SRC}
-COMMAND ${GENERATOR} --generatorSet=${shiboken_BINARY_DIR}/shiboken_generator${CMAKE_RELEASE_POSTFIX}${CMAKE_DEBUG_POSTFIX} --enable-parent-ctor-heuristic
+COMMAND ${GENERATOR} --generatorSet=${shiboken_BINARY_DIR}/shiboken_generator --enable-parent-ctor-heuristic
         ${CMAKE_CURRENT_SOURCE_DIR}/global.h
         --include-paths=${libother_SOURCE_DIR}:${libsample_SOURCE_DIR}:${libsample_SOURCE_DIR}/..
         --typesystem-paths=${CMAKE_CURRENT_SOURCE_DIR}:${sample_SOURCE_DIR}

=== tests/samplebinding/CMakeLists.txt ===
--- 
+++ 
@@ -47,10 +47,12 @@
 ${CMAKE_CURRENT_BINARY_DIR}/sample/polygon_wrapper.cpp
 ${CMAKE_CURRENT_BINARY_DIR}/sample/privatector_wrapper.cpp
 ${CMAKE_CURRENT_BINARY_DIR}/sample/privatedtor_wrapper.cpp
+${CMAKE_CURRENT_BINARY_DIR}/sample/protectedenumclass_wrapper.cpp
 ${CMAKE_CURRENT_BINARY_DIR}/sample/protectednonpolymorphic_wrapper.cpp
 ${CMAKE_CURRENT_BINARY_DIR}/sample/protectedpolymorphic_wrapper.cpp
 ${CMAKE_CURRENT_BINARY_DIR}/sample/protectedpolymorphicdaughter_wrapper.cpp
 ${CMAKE_CURRENT_BINARY_DIR}/sample/protectedpolymorphicgranddaughter_wrapper.cpp
+${CMAKE_CURRENT_BINARY_DIR}/sample/protectedproperty_wrapper.cpp
 ${CMAKE_CURRENT_BINARY_DIR}/sample/protectedvirtualdestructor_wrapper.cpp
 ${CMAKE_CURRENT_BINARY_DIR}/sample/reference_wrapper.cpp
 ${CMAKE_CURRENT_BINARY_DIR}/sample/sample_module_wrapper.cpp

=== debian/changelog ===
shiboken (0.3.2-1maemo1) unstable; urgency=low

  * New release

 -- Luciano Miguel Wolf <luciano.wolf@openbossa.org>  Fri, 04 Jun 2010 14:17:35 -0300

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: PySide Team <pyside@openbossa.org>
 XSBC-Original-Maintainer: Debian Python Modules Team <python-modules-team@lists.alioth.debian.org>
 Build-Depends: debhelper7 (>= 7.3.12), cmake (>= 2.6.0),
-	libqt4-dev (>= 4.5.0), libapiextractor-dev (>= 0.5.1), generatorrunner (>= 0.4.2), libgenrunner-dev (>= 0.4.2),
+	libqt4-dev (>= 4.5.0), libapiextractor-dev (>= 0.6.0), generatorrunner (>= 0.5.0), libgenrunner-dev (>= 0.5.0),
 	python-all-dev, python-all-dbg
 XS-Python-Version: >= 2.5
 Standards-Version: 3.8.4
@@ -26,8 +26,8 @@
 Package: libshiboken0.3
 Section: libs
 Architecture: any
-Conflicts: libshiboken0 (<< 0.3.0)
-Replaces: libshiboken0 (<< 0.3.0)
+Conflicts: libshiboken0 (<< 0.3)
+Replaces: libshiboken0 (<< 0.3)
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: CPython bindings generator for C++ libraries - shared library
  Shiboken is a bindings generator for C++ libraries that outputs CPython

=== debian/rules ===
--- 
+++ 
@@ -23,6 +23,7 @@
 	-DCMAKE_MODULE_PATH="$(shell pwd)/debian/cmake" \
 	-DCMAKE_PYTHON_VERSION="$*-dbg;$*" \
 	-DCMAKE_PYTHONLIB_VERSION="$*_d;$*" \
+	-DBUILD_TESTS=FALSE \
 	-DCMAKE_DEBUG_POSTFIX=$(shell echo -py$*_d | sed -e 's/\.//g' -)
 
 override_dh_auto_configure-%:
@@ -33,6 +34,7 @@
 	-DCMAKE_MODULE_PATH="$(shell pwd)/debian/cmake" \
 	-DCMAKE_PYTHON_VERSION=$* \
 	-DCMAKE_PYTHONLIB_VERSION=$* \
+	-DBUILD_TESTS=FALSE \
 	-DCMAKE_RELEASE_POSTFIX=$(shell echo -py$* | sed -e 's/\.//g' -)
 
 #### BUILD ####

## shiboken 0.4.0-1maemo1

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,9 +3,14 @@
 
 cmake_minimum_required(VERSION 2.6)
 
+set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake/Modules/
+                      ${CMAKE_MODULE_PATH})
+
 find_package(Qt4 4.5.0 REQUIRED)
-find_package(ApiExtractor REQUIRED)
-find_package(GeneratorRunner REQUIRED)
+find_package(ApiExtractor 0.7 REQUIRED)
+find_package(GeneratorRunner 0.6 REQUIRED)
+find_package(PythonLibs REQUIRED)
+find_package(PythonInterpWithDebug REQUIRED)
 
 add_definitions(${QT_DEFINITIONS})
 
@@ -38,8 +43,8 @@
 set(LIB_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX}" CACHE PATH "The subdirectory relative to the install prefix where libraries will be installed (default is /lib${LIB_SUFFIX})" FORCE)
 
 set(shiboken_MAJOR_VERSION "0")
-set(shiboken_MINOR_VERSION "3")
-set(shiboken_MICRO_VERSION "2")
+set(shiboken_MINOR_VERSION "4")
+set(shiboken_MICRO_VERSION "0")
 set(shiboken_VERSION "${shiboken_MAJOR_VERSION}.${shiboken_MINOR_VERSION}.${shiboken_MICRO_VERSION}")
 
 set(shiboken_SRC
@@ -57,6 +62,7 @@
                     ${QT_QTCORE_INCLUDE_DIR})
 
 add_library(shiboken_generator SHARED ${shiboken_SRC})
+set_property(TARGET shiboken_generator PROPERTY PREFIX "")
 
 target_link_libraries(shiboken_generator
                       ${APIEXTRACTOR_LIBRARY}
@@ -72,6 +78,27 @@
                IMMEDIATE @ONLY)
 add_custom_target(uninstall "${CMAKE_COMMAND}"
                   -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")
+
+# Detect if the python libs were compiled in debug mode
+execute_process(
+    COMMAND ${PYTHON_EXECUTABLE} -c "from distutils import sysconfig; \\
+        print sysconfig.get_config_var('Py_DEBUG')"
+    OUTPUT_VARIABLE PY_DEBUG
+    OUTPUT_STRIP_TRAILING_WHITESPACE)
+
+if(CMAKE_BUILD_TYPE STREQUAL "Debug")
+    if(NOT PYTHON_DEBUG_LIBRARIES)
+        message(FATAL_ERROR "Python debug library not found. Try compile shiboken with -DCMAKE_BUILD_TYPE=Release")
+    endif()
+    if(NOT PY_DEBUG)
+        message(WARNING "Compiling shiboken with debug enabled, but the python executable was not compiled with debug support.")
+    endif()
+    add_definitions("-DPy_DEBUG")
+    set(SBK_PYTHON_LIBRARIES ${PYTHON_DEBUG_LIBRARIES})
+else()
+    set(SBK_PYTHON_LIBRARIES ${PYTHON_LIBRARIES})
+    add_definitions("-DNDEBUG")
+endif()
 
 if (BUILD_TESTS)
     enable_testing()

=== libshiboken/CMakeLists.txt ===
project(libshiboken)

#Find installed sparsehash
find_path(SPARSEHASH_INCLUDE_PATH sparseconfig.h PATH_SUFFIXES "/google/sparsehash")
if(SPARSEHASH_INCLUDE_PATH)
    message(STATUS "Using system hash found in: ${SPARSEHASH_INCLUDE_PATH}")
else()
    set(SPARSEHASH_INCLUDE_PATH ${CMAKE_SOURCE_DIR}/ext/sparsehash)
endif()

set(libshiboken_MAJOR_VERSION ${shiboken_MAJOR_VERSION})
set(libshiboken_MINOR_VERSION ${shiboken_MINOR_VERSION})
set(libshiboken_MICRO_VERSION ${shiboken_MICRO_VERSION})
set(libshiboken_VERSION "${libshiboken_MAJOR_VERSION}.${libshiboken_MINOR_VERSION}.${libshiboken_MICRO_VERSION}")
set(libshiboken_SOVERSION "${libshiboken_MAJOR_VERSION}.${libshiboken_MINOR_VERSION}")

configure_file("${CMAKE_CURRENT_SOURCE_DIR}/ShibokenConfig.cmake.in"
               "${CMAKE_CURRENT_BINARY_DIR}/ShibokenConfig.cmake" @ONLY)
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/ShibokenConfigVersion.cmake.in"
               "${CMAKE_CURRENT_BINARY_DIR}/ShibokenConfigVersion.cmake" @ONLY)
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/shiboken.pc.in"
               "${CMAKE_CURRENT_BINARY_DIR}/shiboken.pc" @ONLY)

set(libshiboken_SRC
basewrapper.cpp
helper.cpp
pyenum.cpp
bindingmanager.cpp
typeresolver.cpp
)

include_directories(${CMAKE_CURRENT_SOURCE_DIR}
                    ${PYTHON_INCLUDE_PATH}
                    ${SPARSEHASH_INCLUDE_PATH})
add_library(libshiboken SHARED ${libshiboken_SRC})
set_property(TARGET libshiboken PROPERTY PREFIX "")
target_link_libraries(libshiboken ${SBK_PYTHON_LIBRARIES})
set_target_properties(libshiboken PROPERTIES VERSION ${libshiboken_VERSION} SOVERSION ${libshiboken_SOVERSION})

install(FILES
        autodecref.h
        basewrapper.h
        bindingmanager.h
        conversions.h
        gilstate.h
        helper.h
        pyenum.h
        python25compat.h
        sbkdbg.h
        shiboken.h
        shibokenmacros.h
        threadstatesaver.h
        typeresolver.h
        DESTINATION include/shiboken)
install(TARGETS libshiboken DESTINATION "${LIB_INSTALL_DIR}")
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/ShibokenConfig.cmake"
        DESTINATION "${LIB_INSTALL_DIR}/cmake/Shiboken-${libshiboken_VERSION}")
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/ShibokenConfigVersion.cmake"
        DESTINATION "${LIB_INSTALL_DIR}/cmake/Shiboken-${libshiboken_VERSION}")
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/shiboken.pc"
        DESTINATION "${LIB_INSTALL_DIR}/pkgconfig")

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -8,17 +8,20 @@
 set(test_blacklist "")
 
 find_package(PythonInterp REQUIRED)
+if(NOT CTEST_TESTING_TIMEOUT)
+    set(CTEST_TESTING_TIMEOUT 60)
+endif()
 
 foreach(test_file ${TEST_FILES})
     string(REGEX MATCH "/([^/]+)_test.py" test_name ${test_file})
     list(FIND test_blacklist ${CMAKE_MATCH_1} expect_fail)
     add_test("${CMAKE_MATCH_1}" sh
              "${CMAKE_CURRENT_SOURCE_DIR}/run_test.sh"
-             "${libsample_BINARY_DIR}:${libshiboken_BINARY_DIR}"
+             "${libsample_BINARY_DIR}:${libother_BINARY_DIR}:${libshiboken_BINARY_DIR}"
              "${sample_BINARY_DIR}:${other_BINARY_DIR}"
              "${PYTHON_EXECUTABLE}"
              "${test_file}")
-    set_tests_properties(${CMAKE_MATCH_1} PROPERTIES TIMEOUT 5)
+    set_tests_properties(${CMAKE_MATCH_1} PROPERTIES TIMEOUT ${CTEST_TESTING_TIMEOUT})
     if (${expect_fail} GREATER -1)
         set_tests_properties(${CMAKE_MATCH_1} PROPERTIES WILL_FAIL TRUE)
     endif(${expect_fail} GREATER -1)

=== tests/otherbinding/CMakeLists.txt ===
--- 
+++ 
@@ -16,7 +16,7 @@
 find_program(GENERATOR generatorrunner REQUIRED)
 
 add_custom_command(OUTPUT ${other_SRC}
-COMMAND ${GENERATOR} --generatorSet=${shiboken_BINARY_DIR}/shiboken_generator --enable-parent-ctor-heuristic
+COMMAND ${GENERATOR} --generatorSet=${shiboken_BINARY_DIR}/shiboken_generator${CMAKE_RELEASE_POSTFIX}${CMAKE_DEBUG_POSTFIX} --enable-parent-ctor-heuristic
         ${CMAKE_CURRENT_SOURCE_DIR}/global.h
         --include-paths=${libother_SOURCE_DIR}:${libsample_SOURCE_DIR}:${libsample_SOURCE_DIR}/..
         --typesystem-paths=${CMAKE_CURRENT_SOURCE_DIR}:${sample_SOURCE_DIR}
@@ -40,7 +40,7 @@
 target_link_libraries(other
                       libother
                       libsample
-                      ${PYTHON_LIBRARIES}
+                      ${SBK_PYTHON_LIBRARIES}
                       libshiboken)
 
 add_dependencies(other sample shiboken_generator)

=== tests/samplebinding/CMakeLists.txt ===
--- 
+++ 
@@ -76,7 +76,7 @@
 find_program(GENERATOR generatorrunner REQUIRED)
 
 add_custom_command(OUTPUT ${sample_SRC}
-COMMAND ${GENERATOR} --generatorSet=${shiboken_BINARY_DIR}/shiboken_generator --enable-parent-ctor-heuristic
+COMMAND ${GENERATOR} --generatorSet=${shiboken_BINARY_DIR}/shiboken_generator${CMAKE_RELEASE_POSTFIX}${CMAKE_DEBUG_POSTFIX} --enable-parent-ctor-heuristic
         ${CMAKE_CURRENT_SOURCE_DIR}/global.h
         --include-paths=${libsample_SOURCE_DIR}
         --typesystem-paths=${CMAKE_CURRENT_SOURCE_DIR}
@@ -95,7 +95,7 @@
 set_property(TARGET sample PROPERTY PREFIX "")
 target_link_libraries(sample
                       libsample
-                      ${PYTHON_LIBRARIES}
+                      ${SBK_PYTHON_LIBRARIES}
                       libshiboken)
 
 add_dependencies(sample shiboken_generator)

=== debian/changelog ===
shiboken (0.4.0-1maemo1) unstable; urgency=low

  * New upstream release.

 -- Lauro Moura <lauro.neto@openbossa.org>  Mon, 02 Aug 2010 16:16:51 -0300

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: PySide Team <pyside@openbossa.org>
 XSBC-Original-Maintainer: Debian Python Modules Team <python-modules-team@lists.alioth.debian.org>
 Build-Depends: debhelper7 (>= 7.3.12), cmake (>= 2.6.0),
-	libqt4-dev (>= 4.5.0), libapiextractor-dev (>= 0.6.0), generatorrunner (>= 0.5.0), libgenrunner-dev (>= 0.5.0),
+	libqt4-dev (>= 4.5.0), libapiextractor-dev (>= 0.7.0), generatorrunner (>= 0.6.0), libgenrunner-dev (>= 0.6.0),
 	python-all-dev, python-all-dbg
 XS-Python-Version: >= 2.5
 Standards-Version: 3.8.4
@@ -23,11 +23,11 @@
  .
  Shiboken is the binding generator used to create the PySide bindings.
 
-Package: libshiboken0.3
+Package: libshiboken0.4
 Section: libs
 Architecture: any
-Conflicts: libshiboken0 (<< 0.3)
-Replaces: libshiboken0 (<< 0.3)
+Conflicts: libshiboken0 (<< 0.4)
+Replaces: libshiboken0 (<< 0.4)
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: CPython bindings generator for C++ libraries - shared library
  Shiboken is a bindings generator for C++ libraries that outputs CPython
@@ -40,7 +40,7 @@
 Package: libshiboken-dev
 Section: libdevel
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, libshiboken0.3 (= ${binary:Version})
+Depends: ${shlibs:Depends}, ${misc:Depends}, libshiboken0.4 (= ${binary:Version})
 Description: development files for the shiboken bindings generator library
  Shiboken is a bindings generator for C++ libraries that outputs CPython
  source code. It uses generatorrunner and apiextractor to collect information
@@ -53,7 +53,7 @@
 Section: debug
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends},
-         libshiboken0.3 (= ${binary:Version}),
+         libshiboken0.4 (= ${binary:Version}),
          shiboken (= ${binary:Version})
 Description: debugging symbols for shiboken and its library
  Shiboken is a bindings generator for C++ libraries that outputs CPython
